/* GenericTree.java, v0.1, 16/09/2003
 * 
 * Copyright (c) 2003 Guillaume Arnaud, Inria Rocquencourt.  All rights reserved.
 * 
 */
package datastruct;

import java.util.Vector;

/**
 * Implementation of a generic tree.
 * 
 * @author Guillaume Arnaud
 */
public class GenericTree extends Object implements Cloneable {
	Object node;
	Vector children;
	GenericTree father;

	/**
	 * Default constructor.
	 */
	public GenericTree() {		
		node = new Object();
		children = null;
		father = null;
	}
	/** 
	 * Constructor wich initializes node.
	 */
	public GenericTree(Object n) { 
		node=n;
		children = null;
		father = null;
	}
	/** 
	 * Constructor wich initializes children and node.
	 */
	public GenericTree(Object n,Vector c) { 
		node=n;
		children=c;
		father=null;
	}
	/** 
	 * Constructor wich initializes children, node and father.
	 */
	public GenericTree(Object n,Vector c, GenericTree f) { 
		node=n;
		children=c;
		father=f;
	}

	/**
	 * Adds a child.
	 */
	public void addChild(Object n) {
		if(children==null) children=new Vector();
		children.addElement(n);
	}

	/**
	 * Sets the father
	 */
	public void setFather(GenericTree f) { father=f ; }

	/**
	 * has children ?
	 */
	public boolean children() { return (children!=null); }
	/**
	 * has a father ?
	 */
	public boolean father() { return (father!=null); }
	
}
