// A Graphical User Interface in Java for Constraint Logic Programming
// Copyright (C) 2002 INRIA Francois Fages
// License LGPL
// http://contraintes.inria.fr/~fages/CLPgui

// 10 Dec 2003: Integrated in package datastruct of pavot
// 11 Jan 2002: lists of search trees

package datastruct.clpgui;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class SearchTreeList {
    public SearchTree head;
    public SearchTreeList tail;
    
    SearchTreeList(SearchTree h) {
	head=h;
	tail=null;
    }
    SearchTreeList(String l) {
	head=new SearchTree(l);
	tail=null;
    }
    SearchTreeList(SearchTree h, SearchTreeList t) {
	head=h;
	tail=t;
    }
    SearchTreeList(String l, SearchTreeList t) {
	head=new SearchTree(l);
	tail=t;
    }
    public int length() {
	int r=1;
	SearchTreeList l=this;
	while (l.tail!=null) {
	    r++;
	    l=l.tail;
	}
	return r;
    }
    public SearchTreeList reverse() {
	return reverse(null);
    }
    public SearchTreeList reverse(SearchTreeList a) {
	if (tail==null) return new SearchTreeList(head, a);
	else return tail.reverse(new SearchTreeList(head, a));
    }

    public void revPrettyPrint() {
	if (tail==null) head.prettyPrint();
	else {
	    tail.revPrettyPrint();
	    System.out.print(",");
	    head.prettyPrint();
	}
    }
}
