/* file name  : parser/PropagationHandler.java
 * authors    : Guillaume Arnaud
 * created    : mer 07 avr 2004 17:30:17 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package parser;

import fr.inria.oadymppac.parsing.gentra4cp.TopLevelContentHandler;
import fr.inria.oadymppac.parsing.gentra4cp.TraceContentHandler;
import fr.inria.oadymppac.parsing.gentra4cp.ControlContentHandler;
import fr.inria.oadymppac.parsing.gentra4cp.DefaultBreakPointEvent;
import fr.inria.oadymppac.parsing.gentra4cp.dtd.DTDBreakPointElement;
import fr.inria.oadymppac.parsing.event.EventListener;
import fr.inria.oadymppac.examples.parsing.SingleHeadEventListener;

import parser.propagation.MetaPropagationSolverInterface;
import parser.propagation.MetaPropagationEvent;
import parser.propagation.MetaPropagationListener;
import parser.propagation.MetaPropagationManager;

import request.PropagationRequest;


import java.util.Vector;

public class PropagationHandler extends TraceContentHandler implements MetaPropagationSolverInterface, MetaPropagationListener{
    
    /** 
     * Listeners of meta propagation.
     */
    Vector metaPropagationListeners;

    /** 
     * MetaPropagationManager.
     */
    MetaPropagationManager metaPropagationManager;

    /** 
     * Defines a MetaPropagationSolver object.
     */
    public PropagationHandler() {
        super();
    }

    ///////////////////////////////////////////////////////////////
    protected static void addListener(Object listener, 
			       Vector list) {
	list.addElement(listener);
    }
    
    protected static short removeListener(Object listener,
				   Vector list) {
	short f = 0;
	for (int i = 0; i < list.size(); i++) {
	    if (list.elementAt(i) == listener) {
		list.removeElementAt(i);
	    }
	}
	return f;
    }

    public void error(Exception e) {
	    e.printStackTrace();
    }


    public synchronized void addMetaPropagationListener(MetaPropagationListener l, PropagationRequest pr) {
	if (metaPropagationListeners == null) {
	    metaPropagationListeners = new Vector();
	}
	addListener(l, metaPropagationListeners);
    if(metaPropagationManager==null) 
        metaPropagationManager=new MetaPropagationManager(this,pr);
    metaPropagationManager.addMetaPropagationListener(this);
    }
    public synchronized void removeMetaPropagationListener(MetaPropagationListener l) {
	    removeListener(l,
			   metaPropagationListeners);
	if (metaPropagationListeners.size() == 0) {
	    metaPropagationListeners = null;
	}
    }
    public boolean hasMetaPropagationListener() {
	    return metaPropagationListeners != null;
    }
    public MetaPropagationListener getMetaPropagationListener(int index) {
	    return (MetaPropagationListener)metaPropagationListeners.elementAt(index);
    }
    public void notifyMetaPropagationListener(MetaPropagationEvent ev) {
        if (metaPropagationListeners == null)
            return;
        try {
            for (int i = 0; i < metaPropagationListeners.size(); i++) {
            getMetaPropagationListener(i).notifyMetaPropagationListener(ev);
            }
        }
        catch(Exception e) {
	        error(e);
        }
    } 


    ///////////////////////////////////////////////////////////////////////////
 /*   public void addBreakPointListener(EventListener listener)
        throws ClassNotFoundException, InstantiationException,IllegalAccessException {
        DTDBreakPointElement breakpoint= (DefaultBreakPointEvent) addElement(DTDBreakPointElement.BREAKPOINT, DefaultBreakPointEvent.class);
        addListener(addElement(DTDBreakPointElement.BREAKPOINT,DefaultBreakPointEvent.class),listener);
    }*/

  /*   public void addBreakPointListener(EventListener listener) {
         ControlContentHandler ch=this.getControlHandler();
         ch.addListener(DefaultBreakPointEvent.class, listener);
    }*/
     
    ///////////////////////////////////////////////////////////////////////////

    /** 
     * Sets the MetaPropagationManager.
     * 
     * @param pm MetaPropagationManager
     */
    public void setMetaPropagationManager(MetaPropagationManager pm) {
        metaPropagationManager=pm; }
}
