/* file name  : parser/PropagationSolver.java
 * authors    : Guillaume Arnaud
 * created    : jeu 15 avr 2004 11:37:07 CEST
 * copyright  : 
 *
 * modifications:
 *
 */

package parser;

import org.xml.sax.InputSource;
import org.xml.sax.SAXException;
import org.xml.sax.XMLReader;
import org.xml.sax.helpers.DefaultHandler;

import javax.xml.parsers.SAXParserFactory;
import javax.xml.parsers.SAXParser;
//import org.apache.xerces.parsers.SAXParser;

import control.ThreadControlInterface;
import control.ThreadControl;

import fr.inria.oadymppac.examples.parsing.SingleProvideEventListener;
import fr.inria.oadymppac.examples.parsing.SingleControlEventListener;
import fr.inria.oadymppac.examples.parsing.SingleComplementEventListener;
import fr.inria.oadymppac.examples.parsing.SingleSolverEventListener;
import fr.inria.oadymppac.examples.parsing.SingleHeadEventListener;


/** 
 * 
 * 
 * @author Guillaume Arnaud
 * @version 1.0
 */
public class PropagationSolver extends PropagationHandler implements Runnable {
    //Parser
    SAXParser parser;
    XMLReader reader;
    DefaultHandler defaultHandler;
    InputSource source;
    ThreadControl threadControl;

    SingleHeadEventListener headListener;    
    SingleProvideEventListener providableListener, providedListener;
    SingleControlEventListener controlListener;
    SingleComplementEventListener complementListener;
    SingleSolverEventListener solverListener;
    

    public PropagationSolver(){
        super();            
        try{
            parser=SAXParserFactory.newInstance().newSAXParser();
            defaultHandler=new DefaultHandler();
            reader = parser.getXMLReader();
            reader.setContentHandler(this);
            reader.setDTDHandler(defaultHandler);
            reader.setEntityResolver(defaultHandler);
            reader.setErrorHandler(defaultHandler);            
            
        /*     reader.setDTDHandler(defaultHandler);
            reader.setEntityResolver(defaultHandler);
            reader.setErrorHandler(defaultHandler);*/
            threadControl=new ThreadControl(this);
        }
        catch(Exception e){
            System.out.println("Fail in parser initialization");
			e.printStackTrace();
        }
    }

     public PropagationSolver(InputSource is){
        super();            
        try{
            parser=SAXParserFactory.newInstance().newSAXParser();
            defaultHandler=new DefaultHandler();            
            reader = parser.getXMLReader();
            reader.setContentHandler(this);
            reader.setDTDHandler(defaultHandler);
            reader.setEntityResolver(defaultHandler);
            reader.setErrorHandler(defaultHandler);


/*            parser= new SAXParser();
            defaultHandler=new DefaultHandler();            
            parser.setContentHandler(this);
            parser.setDTDHandler(defaultHandler);
            parser.setEntityResolver(defaultHandler);
            parser.setErrorHandler(defaultHandler);*/
            
            threadControl=new ThreadControl(this);
            threadControl.setDaemon(true);
            source=is;
        }
        catch(Exception e){
            System.out.println("[PropagationSolver] Fail in parser initialization");
			e.printStackTrace();
        }
    }   

     public void setSource(InputSource source){this.source=source;}
    public void setThreadControl(ThreadControl t){
        threadControl=t;
    }
    public ThreadControl getThreadControl() {return threadControl;}

     public void parse(){
         try{
             reader.parse(source);
         }
         catch(Exception e){e.printStackTrace();}
     }
     
    public void parse(InputSource source) {
	    this.source = source;
	    parse();
    }
    

    public void run() {
        parse();
    }    


    public void start(){
        threadControl.start();
    }

    public synchronized void interrupt() throws InterruptedException {
        System.out.println("interrupt");        
        threadControl.myInterrupt();
        System.out.println("is interrupted?");
    }

    public boolean isAlive(){
        return threadControl.isAlive();
    }

    public void restart(){
        System.out.println("Restart");
        try{
            threadControl.notify();
/*             parser=SAXParserFactory.newInstance().newSAXParser();
             defaultHandler=new DefaultHandler();
             reader = parser.getXMLReader();
             reader.setContentHandler(this);
             reader.setDTDHandler(defaultHandler);
             reader.setEntityResolver(defaultHandler);
             reader.setErrorHandler(defaultHandler);*/
             threadControl=new ThreadControl(this);
        }
        catch(Exception e){
            System.out.println("Fail in parser initialization");
			e.printStackTrace();
        }
        this.start();
    }

    protected void init_handlers() {
        System.out.println("[PropagationSolver] init_handlers");
        
        headListener = new SingleHeadEventListener();
        providableListener = new SingleProvideEventListener(SingleProvideEventListener.HEAD);
        providedListener = new SingleProvideEventListener(SingleProvideEventListener.TRACE);
        controlListener = new SingleControlEventListener();
        complementListener = new SingleComplementEventListener();
        solverListener = new SingleSolverEventListener();
        
        this.addDefaultListener(solverListener);
        this.addControlListener(controlListener);
        this.addHeadListener(headListener);
        
        this.addProvidableListener(providableListener);
        this.addProvidedListener(providedListener);
        this.addComplementListener(complementListener);
        System.out.println("[PropagationSolver] init_handlers exit");
    }
    
}
