% A Graphical User Interface for Constraint Logic Programming
% http://contraintes.inria.fr/~fages/CLPGUI
% Copyright (C) 2001,2002 INRIA Francois Fages
% License LGPL-2.1

% Version 2.1.3
% gprolog.pl
% GNU-Prolog compatibility file for CLPGUI
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% Examples
%%%%%%%%%%
:- include('../examples/append.pl').
:- include('../examples/send.pl').
:- include('../examples/queens.pl').
:- include('../examples/bridge.pl').

% Finite domain type
%%%%%%%%%%%%%%%%%%%%
gui_fd(X):- fd_var(X),! ; integer(X).

% Writing finite domains
%%%%%%%%%%%%%%%%%%%%%%%%
gui_print_dom(X):-
    fd_size(X,S),
    gui_printnf(S),
    gui_print(X). % GNU-Prolog representation of finite domains

% Errors
%%%%%%%%
gui_catch_error(G,X,E):-
	catch(G,error(Y,Z),(X=error(Y,Z),E)).

exec(C):-
	exec(C,_,_,_,_).
