package test;
import  fr.inria.oadymppac.examples.parsing.*;
import fr.inria.oadymppac.parsing.gentra4cp.TraceContentHandler;
import org.apache.log4j.Logger;
import fr.inria.oadymppac.utils.log.LogConfigurator;

public class MainTest{
    static Logger logger = Logger.getLogger(MainTest.class);    
    TraceContentHandler mainHandler; 

    SingleHeadEventListener headListener;
    SingleProvideEventListener providableListener, providedListener;
    SingleControlEventListener controlListener;
    SingleComplementEventListener complementListener;
    SingleSolverEventListener solverListener;
    
    public MainTest(){
        init_handlers();
    }

    public static void main(String[] args){
        LogConfigurator.configure();
        MainTest example=new MainTest();
    }

    protected void init_handlers() {
        mainHandler = new TraceContentHandler();
        
        headListener = new SingleHeadEventListener();
        providableListener = new SingleProvideEventListener(SingleProvideEventListener.HEAD);
        providedListener = new SingleProvideEventListener(SingleProvideEventListener.TRACE);
        controlListener = new SingleControlEventListener();
        complementListener = new SingleComplementEventListener();
        solverListener = new SingleSolverEventListener();
        
        System.out.println("[SingleParserExample] addDefaultListener?");
        mainHandler.addDefaultListener(solverListener);
        System.out.println("[SingleParserExample] addDefaultListener ok");
        
        mainHandler.addControlListener(controlListener);
        
        
        mainHandler.addHeadListener(headListener);
        
        mainHandler.addProvidableListener(providableListener);
        mainHandler.addProvidedListener(providedListener);
        mainHandler.addComplementListener(complementListener);
    }    
}
