/* file name  : viewer/PavotViewer.java
 * authors    : Guillaume Arnaud
 * created    : ven 02 avr 2004 18:16:22 CEST
 * copyright  : 
 *
 * modifications:
 *
 */
package viewer;

import java.awt.Container;

/** 
 * This interface must a superclass of all viewer integrated in Pavot.
 * 
 * @author Guillaume Arnaud
 * @version 1.0
 */
public interface PavotViewer {
    static final int PROPAGATIONTREE=1;
    static final int CLPGUIDOMAIN2D=2;
    static final int CLPGUIDOMAIN3D=3;
    static final int CLPGUISEARCHTREE=4;

    
    /** 
     * This method is called when there are a changement in data structure of the viewer
     */
    public void refresh();


    /** 
     * Shows this viewer.
     */
    public void reshow();

    /** 
     * Gets the type of this view.
     * 
     * @return int corresponding with one of the 4 constants (PROPAGATIONTREE,CLPGUIDOMAIN2D,CLPGUIDOMAIN3D,CLPGUISEARCHTREE)
     */
    public int getType();
}
